## picotool 0.0~git20210120.0.d54bf53

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(picotool)

if (DEFINED ENV{PICO_SDK_PATH} AND (NOT PICO_SDK_PATH))
    set(PICO_SDK_PATH $ENV{PICO_SDK_PATH})
    message("Using PICO_SDK_PATH from environment ('${PICO_SDK_PATH}')")
endif ()
if (NOT PICO_SDK_PATH)
    message(FATAL_ERROR "PICO_SDK_PATH is not defined")
endif()
get_filename_component(PICO_SDK_PATH "${PICO_SDK_PATH}" REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")
if (NOT EXISTS ${PICO_SDK_PATH})
    message(FATAL_ERROR "Directory '${PICO_SDK_PATH}' not found")
endif ()

set(CMAKE_CXX_STANDARD 14)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

add_subdirectory(picoboot_connection)

find_package(LIBUSB)
if (NOT LIBUSB_FOUND)
    message(FATAL_ERROR "picotool cannot be built because libUSB is not found")
else()
    add_subdirectory(${PICO_SDK_PATH}/src/common/pico_binary_info pico_binary_info)
    add_subdirectory(${PICO_SDK_PATH}/src/common/boot_uf2 boot_uf2_headers)
    add_subdirectory(${PICO_SDK_PATH}/src/common/boot_picoboot boot_picoboot_headers)
    add_subdirectory(${PICO_SDK_PATH}/src/host/pico_platform pico_platform)

    add_executable(picotool main.cpp)
    target_include_directories(picotool PRIVATE ${LIBUSB_INCLUDE_DIR})
    target_link_libraries(picotool pico_binary_info boot_uf2_headers boot_picoboot_headers pico_platform_headers picoboot_connection_cxx ${LIBUSB_LIBRARIES})
endif()

=== debian/changelog ===
picotool (0.0~git20210120.0.d54bf53-1) buster; urgency=medium

  * Remove bundled pico-sdk and use system-wide install
  * Rebase on new master branch

 -- Serge Schneider <serge@raspberrypi.com>  Fri, 22 Jan 2021 17:01:22 +0000

picotool (0.0~git20210119.0.4194550-1) buster; urgency=medium

  * Initial release
  * Built from pico-sdk 0.0~git20210119.0.b992222

 -- Serge Schneider <serge@raspberrypi.com>  Tue, 19 Jan 2021 18:13:24 +0000

=== debian/control ===
Source: picotool
Section: utils
Priority: optional
Maintainer: Serge Schneider <serge@raspberrypi.com>
Build-Depends: debhelper (>= 11), pico-sdk, cmake, pkg-config,
 libusb-1.0-0-dev, help2man
Standards-Version: 4.1.3
Homepage: https://github.com/raspberrypi/picotool/
Vcs-Browser: https://github.com/raspberrypi/picotool/
Vcs-Git: https://github.com/raspberrypi/picotool.git

Package: picotool
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: RP2040 tool
 Tool for interacting with a RP2040 device in BOOTSEL mode,
 or with a RP2040 binary

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPICO_SDK_PATH="/usr/src/pico-sdk"

override_dh_auto_install: debian/picotool.1
	mkdir -p debian/tmp/
	mv obj-$(DEB_TARGET_GNU_TYPE)/picotool debian/tmp/
	dh_auto_install

override_dh_clean:
	rm -f debian/picotool.1
	dh_clean

debian/picotool.1:
	help2man -N --version-string="${DEB_VERSION_UPSTREAM}" --help-option="help" \
		--output=$@ ./obj-$(DEB_TARGET_GNU_TYPE)/picotool

## picotool 1.1.2

=== debian/changelog ===
picotool (1.1.2-2) unstable; urgency=medium

  * debian/rules: use LC_ALL=C.UTF-8 instead of LC_TIME=C.utf8
  * debian/patches: add reproducible.patch, termwidth.patch
  * add patch from upstream to support big endian architectures like s390x
  * debian/picotool.1.in: re-format for 80 columns

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Thu, 06 Jun 2024 08:26:46 +0200

picotool (1.1.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1069290)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 19 Apr 2024 16:08:15 +0200

=== debian/control ===
Source: picotool
Section: libdevel
Priority: optional
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Homepage: https://github.com/raspberrypi/picotool
Vcs-Browser: https://salsa.debian.org/debian/picotool
Vcs-Git: https://salsa.debian.org/debian/picotool.git
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 help2man <!cross>,
 libusb-1.0-0-dev,
 pico-sdk-source,
 pkgconf,

Package: picotool
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: interact with RP2040 devices or binaries
 Tool for interacting with a RP2040 device in BOOTSEL mode, or with a RP2040
 binary. It allows one to load programs onto the device or save programs from
 flash to a file. It allows one to verify device contents or reboot the device.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# for SOURCE_DATE_EPOCH
include /usr/share/dpkg/pkg-info.mk
DATE_MONTH_YEAR=$(shell env LC_ALL=C.UTF-8 date --utc --date=@${SOURCE_DATE_EPOCH} +"%B %Y")

# for DEB_HOST_GNU_TYPE
include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DPICO_SDK_PATH=/usr/src/pico-sdk

execute_before_dh_installman:
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	# native build
	# verify that the contents of debian/picotool.1.in is up-to-date
	help2man -n "interact with RP2040 devices or binaries" --no-info --help-option=help --output=picotool.1 ./obj-$(DEB_HOST_GNU_TYPE)/picotool
	{ \
		awk 'NR == 1 && /DO NOT MODIFY THIS FILE!  It was generated by help2man/ { print }' picotool.1; \
		sed 's/@@DATE@@/$(DATE_MONTH_YEAR)/' debian/picotool.1.in; \
	} | diff -u - picotool.1
endif
	# if this was a cross-build, we can just use the cached debian/picotool.1.in
	# if this was a native build, we verified its contents above
	sed 's/@@DATE@@/$(DATE_MONTH_YEAR)/' debian/picotool.1.in > picotool.1;

execute_after_dh_auto_clean:
	rm -f picotool.1

## picotool 2.0.0

=== debian/changelog ===
picotool (2.0.0-3) unstable; urgency=medium

  * add s390x.patch to fix endian problem on s390x

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Fri, 13 Sep 2024 12:09:33 +0200

picotool (2.0.0-2) unstable; urgency=medium

  * debian/patches: add patch from upstream to install picotool.cmake into
    arch-indep path

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 11 Sep 2024 13:57:36 +0200

picotool (2.0.0-1) unstable; urgency=medium

  * New upstream version 2.0.0
  * drop patches that were applied upstream
  * debian/copyright: document lib/nlohmann_json/*
  * debian/patches:
     - 1000-appstream-metainfo.patch: modalias usb glob needs to be upper-case
     - unset build flags for pico-sdk
     - ensure building pico-sdk does not require picotool
     - do not build pico-sdk with debug symbols to avoid embedding build paths
  * debian/picotool.1.in: refresh
  * debian/picotool.install: wrap-and-sort -ast
  * debian/rules:
     - rebuild xip_ram_perms/xip_ram_perms.elf by passing USE_PRECOMPILED=0
     - disable dh_dwz and dh_strip for /usr/share/picotool/xip_ram_perms.elf
  * debian/control:
     - enforce pico-sdk-source (>= 2.0)
     - bump Standards-Version (no changes)
     - update description for RP2350 support
  * add lintian overrides
  * add blhc: ignore-line-regexp

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 11 Sep 2024 06:05:25 +0200

picotool (1.1.2-3) unstable; urgency=medium

  [ Petter Reinholdtsen ]
  * Add Appstream metainfo announcing HW support (Closes: #1076475)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Wed, 17 Jul 2024 00:51:50 +0200

=== debian/control ===
Source: picotool
Section: libdevel
Priority: optional
Maintainer: Johannes Schauer Marin Rodrigues <josch@debian.org>
Homepage: https://github.com/raspberrypi/picotool
Vcs-Browser: https://salsa.debian.org/debian/picotool
Vcs-Git: https://salsa.debian.org/debian/picotool.git
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 help2man <!cross>,
 libusb-1.0-0-dev,
 pico-sdk-source (>= 2.0),
 pkgconf,

Package: picotool
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: interact with RP2040/RP2350 devices or binaries
 Tool for interacting with a RP2040/RP2350 device in BOOTSEL mode, or with a
 RP2040/RP2350 binary. It allows one to load programs onto the device or save
 programs from flash to a file. It allows one to verify device contents or
 reboot the device.

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
     https://github.com/raspberrypi/picotool/tags \
     (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## picotool 2.1.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(picotool)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if (DEFINED ENV{PICO_SDK_PATH} AND (NOT PICO_SDK_PATH))
    set(PICO_SDK_PATH $ENV{PICO_SDK_PATH})
    message("Using PICO_SDK_PATH from environment ('${PICO_SDK_PATH}')")
endif ()
if (NOT PICO_SDK_PATH)
    message(FATAL_ERROR "PICO_SDK_PATH is not defined")
endif()
get_filename_component(PICO_SDK_PATH "${PICO_SDK_PATH}" REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")
if (NOT EXISTS ${PICO_SDK_PATH})
    message(FATAL_ERROR "Directory '${PICO_SDK_PATH}' not found")
endif ()
include(${PICO_SDK_PATH}/pico_sdk_version.cmake)

if (PICO_SDK_VERSION_STRING VERSION_LESS "2.1.0")
    message(FATAL_ERROR "Raspberry Pi Pico SDK version 2.1.0 (or later) required. Your version is ${PICO_SDK_VERSION_STRING}")
endif()

# Set PICOTOOL_CODE_OTP to compile OTP definitions in - otherwise, they are included from JSON
if (NOT PICOTOOL_CODE_OTP)
    set(PICOTOOL_CODE_OTP 0)
endif()

# allow installing to flat dir
include(GNUInstallDirs)
if (PICOTOOL_FLAT_INSTALL)
    set(INSTALL_CONFIGDIR picotool)
    set(INSTALL_DATADIR picotool)
    set(INSTALL_BINDIR picotool)
else()
    set(INSTALL_CONFIGDIR lib/cmake/picotool)
    set(INSTALL_DATADIR ${CMAKE_INSTALL_DATADIR}/picotool)
    set(INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
endif()

# todo better install paths for this
set(DATA_LOCS "./" "${CMAKE_INSTALL_PREFIX}/${INSTALL_DATADIR}/")
message(${DATA_LOCS})
string(REGEX REPLACE ";" "\",\"" DATA_LOCS_VEC "${DATA_LOCS}")
configure_file(data_locs.template.cpp ${CMAKE_CURRENT_BINARY_DIR}/data_locs.cpp)


include(ExternalProject)

if (MSVC)
    set(CMAKE_CXX_STANDARD 20)
else()
    set(CMAKE_CXX_STANDARD 14)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

if (NOT PICOTOOL_NO_LIBUSB)
    # compile xip_ram_perms.elf
    if (NOT DEFINED USE_PRECOMPILED)
        set(USE_PRECOMPILED true)
    endif()
    ExternalProject_Add(xip_ram_perms
            PREFIX xip_ram_perms
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/xip_ram_perms
            BINARY_DIR ${CMAKE_BINARY_DIR}/xip_ram_perms
            CMAKE_ARGS 
                "-DCMAKE_MAKE_PROGRAM:FILEPATH=${CMAKE_MAKE_PROGRAM}"
                "-DPICO_SDK_PATH:FILEPATH=${PICO_SDK_PATH}"
                "-DUSE_PRECOMPILED:BOOL=${USE_PRECOMPILED}"
                "-DPICO_DEBUG_INFO_IN_RELEASE=OFF"
            BUILD_ALWAYS 1 # todo remove this
            INSTALL_COMMAND ""
            )

    set(XIP_RAM_PERMS_ELF ${CMAKE_BINARY_DIR}/xip_ram_perms/xip_ram_perms.elf)
    add_executable(xip_ram_perms_elf IMPORTED)
    add_dependencies(xip_ram_perms_elf xip_ram_perms)
    set_property(TARGET xip_ram_perms_elf PROPERTY IMPORTED_LOCATION ${XIP_RAM_PERMS_ELF})
    # copy xip_ram_perms.elf into build directory
    add_custom_command(TARGET xip_ram_perms
        COMMAND ${CMAKE_COMMAND} -E copy ${XIP_RAM_PERMS_ELF} ${CMAKE_BINARY_DIR}/xip_ram_perms.elf
        DEPENDS xip_ram_perms
    )

    # compile flash_id
    ExternalProject_Add(flash_id
            PREFIX picoboot_flash_id
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/picoboot_flash_id
            BINARY_DIR ${CMAKE_BINARY_DIR}/picoboot_flash_id
            CMAKE_ARGS 
                "-DCMAKE_MAKE_PROGRAM:FILEPATH=${CMAKE_MAKE_PROGRAM}"
                "-DPICO_SDK_PATH:FILEPATH=${PICO_SDK_PATH}"
                "-DUSE_PRECOMPILED:BOOL=${USE_PRECOMPILED}"
                "-DPICO_DEBUG_INFO_IN_RELEASE=OFF"
            BUILD_ALWAYS 1 # todo remove this
            INSTALL_COMMAND ""
            )

    set(FLASH_ID_BIN ${CMAKE_BINARY_DIR}/picoboot_flash_id/flash_id.bin)
    add_executable(flash_id_bin IMPORTED)
    add_dependencies(flash_id_bin flash_id)
    set_property(TARGET flash_id_bin PROPERTY IMPORTED_LOCATION ${FLASH_ID_BIN})
    # copy flash_id.bin into build directory
    add_custom_command(TARGET flash_id
        COMMAND ${CMAKE_COMMAND} -E copy ${FLASH_ID_BIN} ${CMAKE_BINARY_DIR}/flash_id.bin
        DEPENDS flash_id
    )

    # We want to generate headers from WELCOME.HTM etc.
    ExternalProject_Add(otp_header_parser
            PREFIX otp_header_parser
            SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/otp_header_parser
            BINARY_DIR ${CMAKE_BINARY_DIR}/otp_header_parser
            CMAKE_ARGS "-DCODE_OTP=${PICOTOOL_CODE_OTP}"
            BUILD_ALWAYS 1 # todo remove this
            DOWNLOAD_COMMAND ""
            INSTALL_COMMAND ""
            )

    add_executable(otp_header_parse IMPORTED)
    # think this is the best way to do this - this should work in MSVC now, and possibly Xcode but that's untested
    add_dependencies(otp_header_parse otp_header_parser)
    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    if (is_multi_config)
        # use the first config
        list(GET CMAKE_CONFIGURATION_TYPES 0 tmp_config)
        set_property(TARGET otp_header_parse PROPERTY IMPORTED_LOCATION ${CMAKE_BINARY_DIR}/otp_header_parser/${tmp_config}/otp_header_parse)
    else()
        set_property(TARGET otp_header_parse PROPERTY IMPORTED_LOCATION ${CMAKE_BINARY_DIR}/otp_header_parser/otp_header_parse)
    endif()

    if (PICOTOOL_CODE_OTP)
        set(GENERATED_H ${CMAKE_CURRENT_BINARY_DIR}/otp_contents.h)
        add_custom_target(generate_otp_header DEPENDS ${GENERATED_H})
        add_custom_command(OUTPUT ${GENERATED_H}
                COMMENT "Generating ${GENERATED_H}"
                DEPENDS ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h
                COMMAND otp_header_parse ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h ${GENERATED_H}
                )
    elseif(MSVC)
        set(GENERATED_JSON ${CMAKE_CURRENT_BINARY_DIR}/rp2350_otp_contents.json)
        add_custom_target(generate_otp_header DEPENDS ${GENERATED_JSON})
        add_custom_command(OUTPUT ${GENERATED_JSON}
                COMMENT "Generating ${GENERATED_JSON}"
                DEPENDS ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h
                COMMAND otp_header_parse ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h ${GENERATED_JSON}
                )
        # Cannot include json in the binary, as the string is too long, so needs to use pre-generated xxd output
        configure_file(${CMAKE_CURRENT_LIST_DIR}/otp_header_parser/rp2350.json.h ${CMAKE_CURRENT_BINARY_DIR}/rp2350.json.h COPYONLY)
    else()
        set(GENERATED_JSON ${CMAKE_CURRENT_BINARY_DIR}/rp2350_otp_contents.json)
        add_custom_target(generate_otp_header DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rp2350.json.h)
        add_custom_command(OUTPUT ${GENERATED_JSON}
                COMMENT "Generating ${GENERATED_JSON}"
                DEPENDS ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h
                COMMAND otp_header_parse ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include/hardware/regs/otp_data.h ${GENERATED_JSON}
                )
        add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rp2350.json.h
                COMMAND ${CMAKE_COMMAND}
                    -D GENERATED_JSON=${GENERATED_JSON}
                    -P ${CMAKE_CURRENT_LIST_DIR}/cmake/jsonh.cmake
                DEPENDS ${GENERATED_JSON}
                COMMENT "Configuring rp2350.json.h"
                VERBATIM)
              
    endif()
endif()

add_custom_target(binary_data DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/rp2350.rom.h
        ${CMAKE_CURRENT_BINARY_DIR}/xip_ram_perms_elf.h
        ${CMAKE_CURRENT_BINARY_DIR}/flash_id_bin.h)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rp2350.rom.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${CMAKE_CURRENT_LIST_DIR}/bootrom.end.bin
            -D OUTPUT_NAME=rp2350.rom
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        COMMENT "Configuring rp2350.rom.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/xip_ram_perms_elf.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${XIP_RAM_PERMS_ELF}
            -D OUTPUT_NAME=xip_ram_perms_elf
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        DEPENDS xip_ram_perms
        COMMENT "Configuring xip_ram_perms_elf.h"
        VERBATIM)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/flash_id_bin.h
        COMMAND ${CMAKE_COMMAND}
            -D BINARY_FILE=${FLASH_ID_BIN}
            -D OUTPUT_NAME=flash_id_bin
            -P ${CMAKE_CURRENT_LIST_DIR}/cmake/binh.cmake
        DEPENDS flash_id
        COMMENT "Configuring flash_id_bin.h"
        VERBATIM)

add_subdirectory(errors)

add_subdirectory(picoboot_connection)
add_subdirectory(elf)
add_subdirectory(elf2uf2)

# To configure mbedtls
# todo make the configuration better
set(MBEDTLS_CONFIG_FILE "mbedtls_config.h")
add_compile_options(-I${CMAKE_SOURCE_DIR}/lib/include)

add_subdirectory(lib)

add_subdirectory(bintool)

if (NOT PICOTOOL_NO_LIBUSB)
    find_package(LIBUSB)
    set(OTP_EXE otp.cpp)
else()
    set(OTP_EXE no_otp.cpp)
endif()

add_subdirectory(${PICO_SDK_PATH}/src/common/pico_binary_info pico_binary_info)
add_subdirectory(${PICO_SDK_PATH}/src/common/boot_uf2_headers boot_uf2_headers)
add_subdirectory(${PICO_SDK_PATH}/src/common/boot_picoboot_headers boot_picoboot_headers)
add_subdirectory(${PICO_SDK_PATH}/src/common/boot_picobin_headers boot_picobin_headers)
add_subdirectory(${PICO_SDK_PATH}/src/common/pico_usb_reset_interface_headers pico_usb_reset_interface_headers)
add_subdirectory(${PICO_SDK_PATH}/src/rp2_common/boot_bootrom_headers boot_bootrom_headers)
add_subdirectory(${PICO_SDK_PATH}/src/host/pico_platform pico_platform)

add_library(regs_headers INTERFACE)
target_include_directories(regs_headers INTERFACE ${PICO_SDK_PATH}/src/rp2350/hardware_regs/include)

# Main picotool executable
add_executable(picotool
    data_locs.cpp
    ${OTP_EXE}
    main.cpp)
if (NOT PICOTOOL_NO_LIBUSB)
    target_sources(picotool PRIVATE xip_ram_perms.cpp)
    add_dependencies(picotool generate_otp_header xip_ram_perms_elf binary_data)
endif()
set(PROJECT_VERSION 2.1.1)
set(PICOTOOL_VERSION 2.1.1)
set(SYSTEM_VERSION "${CMAKE_SYSTEM_NAME}")
set(COMPILER_INFO "${CMAKE_C_COMPILER_ID}-${CMAKE_C_COMPILER_VERSION}, ${CMAKE_BUILD_TYPE}")
target_compile_definitions(picotool PRIVATE
        PICOTOOL_VERSION="${PICOTOOL_VERSION}"
        SYSTEM_VERSION="${SYSTEM_VERSION}"
        COMPILER_INFO="${COMPILER_INFO}"
        SUPPORT_A2=1
        CODE_OTP=${PICOTOOL_CODE_OTP}
        )
# for OTP info
target_include_directories(picotool PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
# todo, this is a bit of an abstraction failure; but don't want to rev the SDK just for this right now
target_include_directories(picotool PRIVATE ${PICO_SDK_PATH}/src/rp2_common/pico_stdio_usb/include)
target_link_libraries(picotool
        pico_binary_info
        boot_uf2_headers
        boot_picoboot_headers
        boot_picobin_headers
        boot_bootrom_headers
        pico_platform_headers
        pico_usb_reset_interface_headers
        regs_headers
        bintool
        elf2uf2
        errors
        nlohmann_json
        whereami)

if (NOT TARGET mbedtls)
    message("mbedtls not found - no signing/hashing support will be built")
    target_compile_definitions(picotool PRIVATE HAS_MBEDTLS=0)
else()
    target_compile_definitions(picotool PRIVATE HAS_MBEDTLS=1)
endif()

if (NOT LIBUSB_FOUND)
    if (PICOTOOL_NO_LIBUSB)
        message("PICOTOOL_NO_LIBUSB is set - no USB support will be built")
    else()
        message("libUSB is not found - no USB support will be built")
    endif()
    target_compile_definitions(picotool PRIVATE HAS_LIBUSB=0)
    target_link_libraries(picotool 
        picoboot_connection_header)
else()
    target_include_directories(picotool PRIVATE ${LIBUSB_INCLUDE_DIR})
    target_compile_definitions(picotool PRIVATE HAS_LIBUSB=1)
    target_link_libraries(picotool 
        picoboot_connection_cxx
        ${LIBUSB_LIBRARIES})
endif()

=== elf/CMakeLists.txt ===
add_library(elf STATIC
        elf_file.cpp)

target_include_directories(elf PUBLIC ${CMAKE_CURRENT_LIST_DIR})

target_link_libraries(elf PRIVATE errors)

=== elf2uf2/CMakeLists.txt ===
add_library(elf2uf2 STATIC
        elf2uf2.cpp)

target_include_directories(elf2uf2 PUBLIC ${CMAKE_CURRENT_LIST_DIR})

target_link_libraries(elf2uf2 PRIVATE boot_uf2_headers elf errors)

=== lib/CMakeLists.txt ===
# Ensure submodules are initialised - no longer needed as there are no submodules
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
    # Update submodules as needed
    option(GIT_SUBMODULE "Check submodules during build" OFF)
    if(GIT_SUBMODULE)
        message(STATUS "Submodule update")
        execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init lib/mbedtls
                        WORKING_DIRECTORY ${PICO_SDK_PATH}
                        RESULT_VARIABLE GIT_SUBMOD_RESULT)
        if(NOT GIT_SUBMOD_RESULT EQUAL "0")
            message("git submodule update --init lib/mbedtls failed with ${GIT_SUBMOD_RESULT}")
        endif()
    endif()
endif()


set(JSON_BuildTests OFF CACHE INTERNAL "")
add_subdirectory(nlohmann_json EXCLUDE_FROM_ALL)

add_subdirectory(whereami EXCLUDE_FROM_ALL)

if(EXISTS "${PICO_SDK_PATH}/lib/mbedtls/CMakeLists.txt")
    option(ENABLE_PROGRAMS "Build Mbed TLS programs." OFF)
    option(ENABLE_TESTING "Build Mbed TLS tests." OFF)
    add_subdirectory(${PICO_SDK_PATH}/lib/mbedtls mbedtls EXCLUDE_FROM_ALL)
endif()

=== picoboot_flash_id/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if (NOT USE_PRECOMPILED)
    set(PICO_NO_PICOTOOL 1)

    # default build type
    set(CMAKE_BUILD_TYPE "MinSizeRel" CACHE STRING "build type")

    # If the user set these environment variables to influence the picotool
    # build, unset them here so that they do not influence the pico-sdk
    # build. This is especially required for flags that are not supported
    # by arm-none-eabi compilers.
    unset(ENV{CFLAGS})
    unset(ENV{CXXFLAGS})
    unset(ENV{LDFLAGS})

    include(${PICO_SDK_PATH}/external/pico_sdk_import.cmake)
    project(flash_id C CXX ASM)
    pico_sdk_init()

    add_executable(flash_id flash_id.c)
    target_link_libraries(flash_id PRIVATE
        hardware_regs hardware_structs hardware_flash_headers
    )
    target_link_options(flash_id PRIVATE -nostartfiles -nodefaultlibs -Ttext=0)
    pico_add_bin_output(flash_id)
    pico_add_dis_output(flash_id)
else()
    project(flash_id C CXX ASM)
    message("Using precompiled flash_id.bin")
    configure_file(${CMAKE_CURRENT_LIST_DIR}/flash_id.bin ${CMAKE_CURRENT_BINARY_DIR}/flash_id.bin COPYONLY)
    # Use manually specified variables
    set(NULL ${CMAKE_MAKE_PROGRAM})
    set(NULL ${PICO_SDK_PATH})
    set(NULL ${PICO_DEBUG_INFO_IN_RELEASE})
endif()

=== lib/whereami/CMakeLists.txt ===
add_library(whereami INTERFACE)

target_sources(whereami INTERFACE
        ${CMAKE_CURRENT_LIST_DIR}/whereami.c
        ${CMAKE_CURRENT_LIST_DIR}/whereami++.cpp)

target_include_directories(whereami INTERFACE ${CMAKE_CURRENT_LIST_DIR})

=== debian/changelog ===
picotool (2.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.1.1+dfsg
  * debian/copyright: exclude xip_ram_perms/xip_ram_perms.elf
  * debian/patches: remove patches that got applied upstream
  * debian/patches/s390x.patch: refresh
  * debian/control: require pico-sdk-source (>= 2.1.0)
  * debian/tests: add autopkgtest from pico-sdk
  * add debian/README.source
  * debian/tests/control: require at least pico-sdk-source (>= 2.1.0)

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Mon, 17 Mar 2025 19:13:57 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  debhelper-compat (= 13),
  help2man <!cross>,
  libusb-1.0-0-dev,
- pico-sdk-source (>= 2.0),
+ pico-sdk-source (>= 2.1.0),
  pkgconf,
 
 Package: picotool

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,20 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DPICO_SDK_PATH=/usr/src/pico-sdk
+	dh_auto_configure -- -DPICO_SDK_PATH=/usr/src/pico-sdk -DUSE_PRECOMPILED=0
+
+# CFLAGS are intentionally missing because 32 bit arm eabi5 firmware files are
+# not given the hardening flags (which would not be supported)
+execute_before_dh_auto_build:
+	@echo 'blhc: ignore-line-regexp: .* -c /.*/xip_ram_perms/set_perms.c'
+	@echo 'blhc: ignore-line-regexp: .* -c /.*/otp_header_parser/otp_header_parse.cpp'
+	@echo 'blhc: ignore-line-regexp: .* -c /usr/src/pico-sdk/.*'
+
+override_dh_dwz:
+	dh_dwz --exclude=/usr/share/picotool/xip_ram_perms.elf
+
+override_dh_strip:
+	dh_strip --exclude=/usr/share/picotool/xip_ram_perms.elf
 
 execute_before_dh_installman:
 ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
@@ -30,4 +43,4 @@
 	sed 's/@@DATE@@/$(DATE_MONTH_YEAR)/' debian/picotool.1.in > picotool.1;
 
 execute_after_dh_auto_clean:
-	rm -f picotool.1
+	rm -f picotool.1 ./xip_ram_perms/xip_ram_perms.elf
